package mmaplayers.fightersearch.dao;

public class FighterDao implements IFighterDao{
    public Fighter<Fighter> fighters = new ArrayList<>();

    @Autowired
    private AppConfig appConfig;
    
    @PostConstruct
    public void init() {
        fighters = CsvParser.readFile(appConfig.getFile(), appConfig.getSeparator(), appConfig.getListSeparator());
    }
    
    @Override
    public Fighter findById(int id) {
        Optional<Fighter> result = fighters
                .stream()
                .filter(f -> f.getId() == id)
                .findFirst();
        return result.orElse(null);
    }

    @Override
    public Collection<Fighter> findAll() {
        return fighters;
    }

    @Override
    public void insert(Fighter fighter) {
        fighters.add(fighter);
    }

    @Override
    public void edit(Fighter fighter) {
        int index = getIndexOf(fighter.getId());
        if (index != -1)
            fighter.set(index, fighter);
    }

    @Override
    public void delete(int id) {
        int index = getIndexOf(id);
        if (index != -1)
            fighters.remove(index);
    }

    private int getIndexOf(int id) {
        boolean find = false;
        int index = 0;

        while (!find && index < fighters.size()) {
            if (fighters.get(index).getId() == id)
                find = true;
            else
                index++;
        }

        return (find) ? index : -1;
    }
}
