package mmaplayers.fightersearch.service;

import mmaplayers.fightersearch.dao.IFighterDao;
import mmaplayers.fightersearch.model.Fighter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.Arrays;
import java.util.Collection;
import java.util.function.Predicate;
import java.util.stream.Collectors;

public class FighterQueryService implements IFightQueryService {

	 @Autowired
	    IFighterDao iFighterDao;
	
	 private Predicate<Fighter> predicate;

	    @PostConstruct
	    public void init() {
	        predicate = null;
	    }

	    @Override
	    public Collection<Book> exec() {
	        return iFighterDao.findAll()
	                .stream()
	                .filter(predicate)
	                .collect(Collectors.toList());
	    }

	    @Override
	    public IFighterQueryService anyCategorie(String... categorie) {
	        Predicate<Fighter> pAnyCategorie = (fighter -> Arrays.stream(categories).anyMatch(fighter.getCategorie()::contains));
	        predicate = (predicate == null) ? pAnyCategorie : predicate.and(pAnyCategorie);
	        return this;
	    }

	    @Override
	    public IFighterQueryService allCategories(String... categories) {
	        Predicate<Fighter> pAnyCategorie = (fighter -> Arrays.stream(categories).allMatch(book.getCategorie()::contains));
	        predicate = (predicate == null) ? pAnyCategorie : predicate.and(pAnyCategorie);
	        return this;
	    }

	    @Override
	    public IFighterQueryService anyName(String name) {
	        Predicate<Fighter> pNameContains  = (fighter -> fighter.getName().toLowerCase().contains(name.toLowerCase()));
	        predicate = (predicate == null) ? pNameContains : predicate.and(pNameContains);

	        return this;
	    }
}
